Vcenter Vm Guest Processes create

Vcenter Vm Guest Processes create

Starts a program in the guest operating system.

A process started this way can have its status queried with POST /vcenter/vm/{vm}/guest/processes?action=list or POST /vcenter/vm/{vm}/guest/processes/{pid}?action=get. When the process completes, its exit code and end time will be available for 5 minutes after completion.

This operation was added in vSphere API 7.0.2.0.

Returns an authorization error if you do not have all of the privileges described as follows:

  • The resource VirtualMachine referenced by the parameter vm requires VirtualMachine.GuestOperations.Execute.
Request
URI
POST
https://{host}/api/vcenter/vm/{vm}/guest/processes?action=create
COPY
Path Parameters
string
vm
Required  

Virtual machine to perform the operation on.

The parameter must be an identifier for the resource type: VirtualMachine.


Request Body

Request body for invoking operation: create

Show optional properties

{
    "credentials": {
        "interactive_session": false,
        "type": "string"
    },
    "spec": {
        "path": "string"
    }
}
{
    "credentials": {
        "interactive_session": false,
        "type": "string",
        "user_name": "string",
        "password": "string",
        "saml_token": "string"
    },
    "spec": {
        "path": "string",
        "arguments": "string",
        "working_directory": "string",
        "environment_variables": {
            "environment_variables": "string"
        },
        "start_minimized": false
    }
}
credentials
Required  

The Vcenter Vm Guest Credentials schema defines the guest credentials used for guest operation authentication.

This schema was added in vSphere API 7.0.2.0.

spec
Required  

The Vcenter Vm Guest Processes CreateSpec schema describes the arguments to POST /vcenter/vm/{vm}/guest/processes?action=create.

This schema was added in vSphere API 7.0.2.0.

Authentication
This operation uses the following authentication methods.
Responses
201

The process id of the program started.

Returns integer of type(s) application/json
Operation doesn't return any data structure

400

Vapi Std Errors InvalidArgument:

  • if the Vcenter Vm Guest Processes CreateSpec.start_minimized property is set and the guest is not a Windows operating system.
  • if the program path is not a valid path. The value of Vapi Std Errors Error.data will contain all the properties defined in the Vcenter Vm Guest Filesystem FileErrorDetails providing additional information about the failure.
  • if the working directory is not a valid directory. The value of Vapi Std Errors Error.data will contain all the properties defined in the Vcenter Vm Guest Filesystem FileErrorDetails providing additional information about the failure.

Vapi Std Errors NotAllowedInCurrentState if the virtual machine vm is not running.

Vapi Std Errors Unsupported:

  • if the operation is not supported by the VMware tools in the guest OS.
  • if the operation is disabled by the VMware tools in the guest OS.
Returns Vapi Std Errors Error of type(s) application/json
{
    "messages": [
        {
            "id": "string",
            "default_message": "string",
            "args": [
                "string"
            ],
            "params": {
                "params": {
                    "s": "string",
                    "dt": "string",
                    "i": 0,
                    "d": "number",
                    "l": {
                        "id": "string",
                        "params": {
                            "params": "Vapi Std LocalizationParam Object"
                        }
                    },
                    "format": "string",
                    "precision": 0
                }
            },
            "localized": "string"
        }
    ],
    "data": {},
    "error_type": "string"
}
array of object
messages
Required  

Stack of one or more localizable messages for human error consumers.

The message at the top of the stack (first in the list) describes the error from the perspective of the operation the client invoked.

Each subsequent message in the stack describes the "cause" of the prior message.

object
data
Optional

Data to facilitate clients responding to the operation reporting a standard error to indicating that it was unable to complete successfully.

Operations may provide data that clients can use when responding to errors. Since the data that clients need may be specific to the context of the operation reporting the error, different operations that report the same error may provide different data in the error. The documentation for each each operation will describe what, if any, data it provides for each error it reports.

The Vapi Std Errors ArgumentLocations, Vapi Std Errors FileLocations, and Vapi Std Errors TransientIndication schemas are intended as possible values for this property. Vapi Std DynamicID may also be useful as a value for this property (although that is not its primary purpose). Some resources may provide their own specific schemas for use as the value of this property when reporting errors from their operations.

Some operations will not set this property when reporting errors.

string
error_type
Required  

Discriminator field to help API consumers identify the structure type.

For more information see: Vapi Std Errors Error Type.

This property was added in vSphere API 6.7.2.

Can be missing or null for compatibility with preceding implementations.


401

if the credentials was not valid.

Returns Vapi Std Errors Unauthenticated of type(s) application/json
This response body class contains all of the following: Vapi Std Errors Error
{
    "messages": [
        {
            "id": "string",
            "default_message": "string",
            "args": [
                "string"
            ],
            "params": {
                "params": {
                    "s": "string",
                    "dt": "string",
                    "i": 0,
                    "d": "number",
                    "l": "Vapi Std NestedLocalizableMessage Object",
                    "format": "string",
                    "precision": 0
                }
            },
            "localized": "string"
        }
    ],
    "data": {},
    "error_type": "string",
    "challenge": "string"
}
string
challenge
Optional

Indicates the authentication challenges applicable to the target API provider. It can be used by a client to discover the correct authentication scheme to use. The exact syntax of the value is defined by the specific provider, the protocol and authentication schemes used.

For example, a provider using REST may adhere to the WWW-Authenticate HTTP header specification, RFC7235, section 4.1. In this case an example challenge value may be: SIGN realm="27da1358-2ba4-11e9-b210-d663bd873d93",sts="http://vcenter/sso?vsphere.local", Basic realm="vCenter"

This property was added in vSphere API 7.0.0.0.

This property is optional because it was added in a newer version than its parent node.


403

if the path property of spec cannot be accessed.

if the path property of spec cannot be run because credentials will not allow the operation.

Returns Vapi Std Errors Unauthorized of type(s) application/json
This response body class contains all of the following: Vapi Std Errors Error
{
    "messages": [
        {
            "id": "string",
            "default_message": "string",
            "args": [
                "string"
            ],
            "params": {
                "params": {
                    "s": "string",
                    "dt": "string",
                    "i": 0,
                    "d": "number",
                    "l": "Vapi Std NestedLocalizableMessage Object",
                    "format": "string",
                    "precision": 0
                }
            },
            "localized": "string"
        }
    ],
    "data": {},
    "error_type": "string",
    "challenge": "string"
}
string
challenge
Optional

Indicates the authentication challenges applicable to the target API provider. It can be used by a client to discover the correct authentication scheme to use. The exact syntax of the value is defined by the specific provider, the protocol and authentication schemes used.

For example, a provider using REST may adhere to the WWW-Authenticate HTTP header specification, RFC7235, section 4.1. In this case an example challenge value may be: SIGN realm="27da158-2ba4-11e9-b",sts="http://vcenter/sso?vsphere.local", Basic realm="vCenter"

This property was added in vSphere API 9.1.0.0.

This property is optional because it was added in a newer version than its parent node.


404

if the virtual machine vm is not found.

if the program path does not exist. The value of Vapi Std Errors Error.data will contain all the properties defined in the Vcenter Vm Guest Filesystem FileErrorDetails providing additional information about the failure.

Returns Vapi Std Errors NotFound of type(s) application/json
This response body class contains all of the following: Vapi Std Errors Error
{
    "messages": [
        {
            "id": "string",
            "default_message": "string",
            "args": [
                "string"
            ],
            "params": {
                "params": {
                    "s": "string",
                    "dt": "string",
                    "i": 0,
                    "d": "number",
                    "l": "Vapi Std NestedLocalizableMessage Object",
                    "format": "string",
                    "precision": 0
                }
            },
            "localized": "string"
        }
    ],
    "data": {},
    "error_type": "string"
}

500

Vapi Std Errors ResourceBusy if the virtual machine is busy.

Vapi Std Errors UnableToAllocateResource if the program fails to start.

Returns Vapi Std Errors Error of type(s) application/json
{
    "messages": [
        {
            "id": "string",
            "default_message": "string",
            "args": [
                "string"
            ],
            "params": {
                "params": {
                    "s": "string",
                    "dt": "string",
                    "i": 0,
                    "d": "number",
                    "l": "Vapi Std NestedLocalizableMessage Object",
                    "format": "string",
                    "precision": 0
                }
            },
            "localized": "string"
        }
    ],
    "data": {},
    "error_type": "string"
}
array of object
messages
Required  

Stack of one or more localizable messages for human error consumers.

The message at the top of the stack (first in the list) describes the error from the perspective of the operation the client invoked.

Each subsequent message in the stack describes the "cause" of the prior message.

object
data
Optional

Data to facilitate clients responding to the operation reporting a standard error to indicating that it was unable to complete successfully.

Operations may provide data that clients can use when responding to errors. Since the data that clients need may be specific to the context of the operation reporting the error, different operations that report the same error may provide different data in the error. The documentation for each each operation will describe what, if any, data it provides for each error it reports.

The Vapi Std Errors ArgumentLocations, Vapi Std Errors FileLocations, and Vapi Std Errors TransientIndication schemas are intended as possible values for this property. Vapi Std DynamicID may also be useful as a value for this property (although that is not its primary purpose). Some resources may provide their own specific schemas for use as the value of this property when reporting errors from their operations.

Some operations will not set this property when reporting errors.

string
error_type
Required  

Discriminator field to help API consumers identify the structure type.

For more information see: Vapi Std Errors Error Type.

This property was added in vSphere API 6.7.2.

Can be missing or null for compatibility with preceding implementations.


503

if the VMware tools are not running.

Returns Vapi Std Errors ServiceUnavailable of type(s) application/json
This response body class contains all of the following: Vapi Std Errors Error
{
    "messages": [
        {
            "id": "string",
            "default_message": "string",
            "args": [
                "string"
            ],
            "params": {
                "params": {
                    "s": "string",
                    "dt": "string",
                    "i": 0,
                    "d": "number",
                    "l": "Vapi Std NestedLocalizableMessage Object",
                    "format": "string",
                    "precision": 0
                }
            },
            "localized": "string"
        }
    ],
    "data": {},
    "error_type": "string"
}

Code Samples
COPY
                    curl -X POST -H 'Authorization: <value>' -H 'Content-Type: application/json' -d '{"credentials":"object","spec":"object"}' https://{api_host}/api/vcenter/vm/{vm}/guest/processes?action=create